extends Node2D

onready var game = $Game
onready var text = $Label
onready var green = $Environment/player_1_light
onready var red = $Environment/player_2_light

var cross = true
var turn = 0
var end = false

var cell_n = {0: Vector2(1, 1), 1: Vector2(2, 1), 2: Vector2(3, 1), 3: Vector2(1, 2), 4: Vector2(2, 2), 5: Vector2(3, 2), 6: Vector2(1, 3), 7: Vector2(2, 3), 8: Vector2(3, 3)}


#Click Timer
var click = null
var click_delay = 0.1
var click_ready = false

#Turn Timer
#var move = null
#var move_delay = 2
#var move_ready = true


func _ready():

	set_process_input(true)

	$Environment/player_1_light.set_color(global.color_1)
	$Environment/player_2_light.set_color(global.color_2)

	#Create Click Timer
	click = Timer.new()
	click.set_one_shot(true)
	click.set_wait_time(click_delay)
	click.connect("timeout", self, "_on_click_timeout")
	add_child(click)

	#Create Move Timer
	# Move Timer was designed to slow instant ai moves,
	#but they are far from instant, so it is not used atm
#	move = Timer.new()
#	move.set_one_shot(true)
#	move.set_wait_time(move_delay)
#	move.connect("timeout", self, "_on_move_timeout")
#	add_child(move)


func _process(delta):

#	var cell = {1: game.get_cell(1, 1), 2: game.get_cell(2, 1), 3: game.get_cell(3, 1), 4: game.get_cell(1, 2), 5: game.get_cell(2, 2), 6: game.get_cell(3, 2), 7: game.get_cell(1, 3), 8: game.get_cell(2, 3), 9: game.get_cell(3, 3)}

	var x1 = game.get_cell(1, 1) + game.get_cell(1, 2) + game.get_cell(1, 3)
	var x2 = game.get_cell(2, 1) + game.get_cell(2, 2) + game.get_cell(2, 3)
	var x3 = game.get_cell(3, 1) + game.get_cell(3, 2) + game.get_cell(3, 3)

	var y1 = game.get_cell(1, 1) + game.get_cell(2, 1) + game.get_cell(3, 1)
	var y2 = game.get_cell(1, 2) + game.get_cell(2, 2) + game.get_cell(3, 2)
	var y3 = game.get_cell(1, 3) + game.get_cell(2, 3) + game.get_cell(3, 3)

	var xy = game.get_cell(1, 1) + game.get_cell(2, 2) + game.get_cell(3, 3)
	var yx = game.get_cell(3, 1) + game.get_cell(2, 2) + game.get_cell(1, 3)


#	var x1 = cell[0] + cell[3] + cell[6]
#	var x2 = cell[1] + cell[4] + cell[7]
#	var x3 = cell[2] + cell[5] + cell[8]

#	var y1 = cell[0] + cell[1] + cell[2]
#	var y2 = cell[3] + cell[4] + cell[5]
#	var y3 = cell[6] + cell[7] + cell[8]

#	var xy = cell[0] + cell[4] + cell[8]
#	var yx = cell[2] + cell[4] + cell[6]


	if (x1 == 9 or x2 == 9 or x3 == 9 or y1 == 9 or y2 == 9 or y3 == 9 or xy == 9 or yx == 9):
		text.set_text("Cross Won")
		end = true
		green.set_shadow_enabled(false)
		red.set_shadow_enabled(false)
		red.set_enabled(false)

	if (x1 == 12 or x2 == 12 or x3 == 12 or y1 == 12 or y2 == 12 or y3 == 12 or xy == 12 or yx == 12):
		text.set_text("Circle Won")
		end = true
		green.set_shadow_enabled(false)
		red.set_shadow_enabled(false)
		green.set_enabled(false)


	if !end:

		if $Panel/as_cross.is_pressed():
			#player goes cross
			if Input.is_action_just_pressed("mouse_lclick") and click_ready and cross:
				var tile = game.world_to_map(get_global_mouse_position())
				if (game.get_cell(tile.x, tile.y) != -1) or (tile.x < 1) or (tile.x > 3) or (tile.y < 1) or (tile.y > 3):
					text.set_text("wrong tile")
				else:
					game.set_cell(tile.x, tile.y, 3)
					_tgt_circle()

			#ai goes circle
			if click_ready and !cross:
				if global.difficulty == 0:
					randomize()
					var tile = Vector2(randi()%3+1, randi()%3+1)
					if game.get_cell(tile.x, tile.y) == -1:
						game.set_cell(tile.x, tile.y, 4)
						_tgt_cross()
					else:
						randomize()
#				if global.difficulty == 1:
#					var board = [game.get_cell(1, 1), game.get_cell(2, 1), game.get_cell(3, 1), game.get_cell(1, 2), game.get_cell(2, 2), game.get_cell(3, 2), game.get_cell(1, 3), game.get_cell(2, 3), game.get_cell(3, 3)]
#					var virtual_board = []
#					virtual_board.resize(9)
#					print ("syncing boards")
#					virtual_board = board
##					print ("syncing boards2")
##					var score = [0, 0, 0, 0, 0, 0, 0, 0, 0]
#					print ("starting for")
#					for i in range (0, 9):
#						print ("trying i:", i)
#						if board [i] == -1:
#							game.set_cell(cell_n[i].x, cell_n[i].y, 4)
#							_tgt_cross()


#							print ("this is an avaliable cell:", i)
#							virtual_board[i] = 4
#							print ("this is real board now:    ", board[0], ", ", board[1], ", ", board[2], ", ", board[3], ", ", board[4], ", ", board[5], ", ", board[6], ", ", board[7], ", ", board[8])
#							print ("this is virtual board now: ", virtual_board[0], ", ", virtual_board[1], ", ", virtual_board[2], ", ", virtual_board[3], ", ", virtual_board[4], ", ", virtual_board[5], ", ", virtual_board[6], ", ", virtual_board[7], ", ", virtual_board[8], "\n")
#							if (virtual_board[0] == virtual_board[1] == virtual_board[2] == 4) or (virtual_board[3] == virtual_board[4] == virtual_board[5] == 4) or (virtual_board[6] == virtual_board[7] == virtual_board[8] == 4) or (virtual_board[0] == virtual_board[3] == virtual_board[6] == 4) or (virtual_board[1] == virtual_board[4] == virtual_board[7] == 4) or (virtual_board[2] == virtual_board[5] == virtual_board[8] == 4) or (virtual_board[0] == virtual_board[4] == virtual_board[8] == 4) or (virtual_board[2] == virtual_board[4] == virtual_board[6] == 4):
#							if (board[0] == board[1] == board[2] == 4) or (board[3] == board[4] == board[5] == 4) or (board[6] == board[7] == board[8] == 4) or (board[0] == board[3] == board[6] == 4) or (board[1] == board[4] == board[7] == 4) or (board[2] == board[5] == board[8] == 4) or (board[0] == board[4] == board[8] == 4) or (board[2] == board[4] == board[6] == 4):
#								print ("I am checking final if")
#								game.set_cell(cell_n[i].x, cell_n[i].y, 4)
#							virtual_board[i] = -1
#						text.set_text("i am retard")
#

#						text.set_text("can't win")
#						if event.is_action_pressed("mouse_lclick"):
#							var tile = game.world_to_map(get_global_mouse_pos())
#							if game.get_cell(tile.x, tile.y) != -1 or tile.x<1 or tile.x>3 or tile.y<1 or tile.y>3:
#								text.set_text("wrong tile")
#							else:
#								game.set_cell(tile.x, tile.y, 4)
#								_tgt_cross()

															#if center is empty - center, then corners, then sides
					#по принципу свободной клетки
#				if global.difficulty == 2:
					#минмакс рекурсия


		else:
			#ai goes cross
			if click_ready and cross:
				if global.difficulty == 0:
					randomize()
					var tile = Vector2(randi()%3+1, randi()%3+1)
					if game.get_cell(tile.x, tile.y) == -1:
						game.set_cell(tile.x, tile.y, 3)
						_tgt_circle()
					else:
						randomize()
#				if global.difficulty == 1:

#				if global.difficulty == 2:

			#player goes circle
			if Input.is_action_just_pressed("mouse_lclick") and click_ready and !cross:
				var tile = game.world_to_map(get_global_mouse_position())
				if (game.get_cell(tile.x, tile.y) != -1) or (tile.x < 1) or (tile.x > 3) or (tile.y < 1) or (tile.y > 3):
					text.set_text("wrong tile")
				else:
					game.set_cell(tile.x, tile.y, 4)
					_tgt_cross()



	if turn == 9 and !end:
		text.set_text("Draw")
		end = true
		green.set_shadow_enabled(false)
		red.set_shadow_enabled(false)
		green.set_enabled(false)
		red.set_enabled(false)




func _on_start_pressed():


	if $Panel/start.is_pressed():
		click_ready = true
		green.set_shadow_enabled(false)
		red.set_shadow_enabled(true)
		text.set_text("Cross")
		$Panel.hide()




func _tgt_circle(): #turn goes to circle
#	$Environment/SamplePlayer.play("check")
	turn += 1
	cross = false
	green.set_shadow_enabled(true)
	red.set_shadow_enabled(false)
	click_ready = false
	text.set_text("Circle")
	click.start()

func _tgt_cross(): #turn goes to cross
#	$Environment/SamplePlayer.play("check")
	turn += 1
	cross = true
	green.set_shadow_enabled(false)
	red.set_shadow_enabled(true)
	click_ready = false
	text.set_text("Cross")
	click.start()

func _on_click_timeout():
	click_ready = true
#func _on_move_timeout():
#	move = true

#func minmax(board, act_player):
#
#	var score = 0
#	score.resize(9)
#	for i in range (1, 9):
#		if cell[i] == -1:
#			if boardact_player wins:
#				score [i] += 10
#			if act_player loses:
#				score [i] -= 10



#func evaluate():
#	if (x1 == 9 or x2 == 9 or x3 == 9 or y1 == 9 or y2 == 9 or y3 == 9 or xy == 9 or yx == 9):
#		return 10
#	if (x1 == 12 or x2 == 12 or x3 == 12 or y1 == 12 or y2 == 12 or y3 == 12 or xy == 12 or yx == 12):
#		return -10
#	else:
#		return 0
#
#func minmax(var depth, var isMax):
#	var score = evaluate()
#	if score == 10:
#		return score
#	if score == -10:
#		return score
#	if turn == 9 and !end:
#		return 0
#	if isMax:
#		var best = -1000
#		for c in range (1, 9):
#			if game.get_cell(cell_n[c]) == -1:
#				game.set_cell(cell_n[c], 3)
#				best = max(best, minmax(depth+1, !isMax))
#				game.set_cell(cell_n[c], -1)
#		return best
#	else:
#		var best = 1000
#		for c in range (1, 9):
#			if game.get_cell(cell_n[c]) == -1:
#				game.set_cell(cell_n[c], 4)
#				best = max(best, minmax(depth+1, !isMax))
#				game.set_cell(cell_n[c], -1)
#		return best









