extends Node2D

onready var game = $Game
onready var text = $Label
onready var green = $Environment/player_1_light
onready var red = $Environment/player_2_light

var cross = true
var turn = 0
var end = false

#Timer
var timer = null
var click_delay = 0.1
var ready = false

func _ready():

	set_process_input(true)

	$Environment/player_1_light.set_color(global.color_1)
	$Environment/player_2_light.set_color(global.color_2)

	#Create timer
	timer = Timer.new()
	timer.set_one_shot(true)
	timer.set_wait_time(click_delay)
	timer.connect("timeout", self ,"_on_timer_timeout")
	add_child(timer)

func _process(delta):

	var x1 = game.get_cell(1, 1) + game.get_cell(1, 2) + game.get_cell(1, 3)
	var x2 = game.get_cell(2, 1) + game.get_cell(2, 2) + game.get_cell(2, 3)
	var x3 = game.get_cell(3, 1) + game.get_cell(3, 2) + game.get_cell(3, 3)

	var y1 = game.get_cell(1, 1) + game.get_cell(2, 1) + game.get_cell(3, 1)
	var y2 = game.get_cell(1, 2) + game.get_cell(2, 2) + game.get_cell(3, 2)
	var y3 = game.get_cell(1, 3) + game.get_cell(2, 3) + game.get_cell(3, 3)

	var xy = game.get_cell(1, 1) + game.get_cell(2, 2) + game.get_cell(3, 3)
	var yx = game.get_cell(3, 1) + game.get_cell(2, 2) + game.get_cell(1, 3)

	if turn <= 8 and !end:
		
		if Input.is_action_just_pressed("mouse_lclick") and ready and cross:
			var tile = game.world_to_map(get_global_mouse_position())
			if (game.get_cell(tile.x, tile.y) != -1) or (tile.x < 1) or (tile.x > 3) or (tile.y < 1) or (tile.y > 3):
				text.set_text("wrong tile")
			elif (game.get_cell(tile.x, tile.y) == -1) and (1 <= tile.x) and (tile.x <= 3) and (1 <= tile.y) and (tile.y <= 3):
				game.set_cell(tile.x, tile.y, 3)
				turn += 1
				cross = false
				green.set_shadow_enabled(true)
				red.set_shadow_enabled(false)
				text.set_text("Circle")
			ready = false
			timer.start()

		if Input.is_action_just_pressed("mouse_lclick") and ready and !cross:
			var tile = game.world_to_map(get_global_mouse_position())
			if (game.get_cell(tile.x, tile.y) != -1) or (tile.x < 1) or (tile.x > 3) or (tile.y < 1) or (tile.y > 3):
				text.set_text("wrong tile")
			elif (game.get_cell(tile.x, tile.y) == -1) and (1 <= tile.x) and (tile.x <= 3) and (1 <= tile.y) and (tile.y <= 3):
				game.set_cell(tile.x, tile.y, 4)
				turn += 1
				cross = true
				green.set_shadow_enabled(false)
				red.set_shadow_enabled(true)
				text.set_text("Cross")
			ready = false
			timer.start()



	if (x1 == 9 or x2 == 9 or x3 == 9 or y1 == 9 or y2 == 9 or y3 == 9 or xy == 9 or yx == 9):
		text.set_text("Cross Won")
		end = true
		green.set_shadow_enabled(false)
		red.set_shadow_enabled(false)
		red.set_enabled(false)

	if (x1 == 12 or x2 == 12 or x3 == 12 or y1 == 12 or y2 == 12 or y3 == 12 or xy == 12 or yx == 12):
		text.set_text("Circle Won")
		end = true
		green.set_shadow_enabled(false)
		red.set_shadow_enabled(false)
		green.set_enabled(false)

	if turn == 9 and !end:
		text.set_text("Draw")
		end = true
		green.set_shadow_enabled(false)
		red.set_shadow_enabled(false)
		green.set_enabled(false)
		red.set_enabled(false)





func _input(event):


	pass


func _on_timer_timeout():
	ready = true


func _on_start_pressed():
	ready = true
	green.set_shadow_enabled(false)
	red.set_shadow_enabled(true)
	text.set_text("Cross")
	$start.hide()
