extends Node2D

#start udp
var udp = PacketPeerUDP.new()

func _ready():

	#load global color values
	$Game/Environment/player_1_light.set_color(global.color_1)
	$Game/Environment/player_2_light.set_color(global.color_2)



func _process(delta):

	if !udp.is_listening():
		return

	while(udp.get_available_packet_count() > 0):
		var packet = udp.get_var()
		if (typeof(packet) == TYPE_STRING):
				var host = udp.get_packet_ip()
				var port = udp.get_packet_port()
				$chat/text.add_text("(" + host + ":" + str(port) + ":) " + packet)
				$chat/text.newline()


func _on_connect_toggled(pressed):
	if (pressed):
		var err = udp.listen(global.listen_port)
		if (err != OK):
			$status.set_text("Error:\nCan't listen.")
			$connect.set_pressed(false)
		else:
			$status.set_text("Connected.")
			$connect.set_text("Disconnect")
			err = udp.set_dest_address(global.connect_ip, global.connect_port)
			if (err != OK):
				$status.set_text("Error:\nCan't resolve.")
				$connect.set_pressed(false)
			else:
				send_message("* " + global.username + " entered the game.")
	else:
		udp.close()
		$status.set_text("Disconnected.")
		$connect.set_text("Connect")


func send_message(text):

	if (udp.is_listening()):
		udp.put_var(text)
		$chat/text.add_text("(Self:) " + text)
		$chat/text.newline()


func _on_entry_line_text_entered(text):
	_on_entry_button_pressed()


func _on_entry_button_pressed():
	var msg = $entry_line.get_text()
	if (msg == ""):
		return
	send_message(global.username + "> " + msg)
	$entry_line.set_text("")


func _on_quit_to_menu_pressed():
		get_tree().change_scene("Scenes/Menu_Main.tscn")
