extends Node2D

func _ready():


	#load global color values
	$Game/Environment/player_1_light.set_color(global.color_1)
	$Game/Environment/player_2_light.set_color(global.color_2)



	if server:
		var host = NetworkedMultiplayerENet.new()
		host.create_server(SERVER_PORT, 2)
		get_tree().set_network_peer(host)

	if client:
		var host = NetworkedMultiplayerENet.new()
		host.create_client(ip, SERVER_PORT)
		get_tree().set_network_peer(host)


remote func pre_configure_game():
    # Load world
    var world = load(which_level).instance()
    get_node("/root").add_child(world)

    # Load my player
    var my_player = preload("res://player.tscn").instance()
    my_player.set_name(str(get_tree().get_network_unique_id()))
    my_player.set_network_mode(NETWORK_MODE_MASTER) # Will be explained later
    get_node("/root/world/players").add_child(my_player)

    # Load other players
    for p in player_info:
        var player = preload("res://player.tscn").instance()
        player.set_name(str(p))
        player.set_network_mode(NETWORK_MODE_SLAVE) # Will be explained later
        get_node("/root/world/players").add_child(player)

    # Tell server (remember, server is always ID=1) that this peer is done pre-configuring
    rpc_id(1, "done_preconfiguring", get_tree().get_network_unique_id())




remote func pre_configure_game():
    get_tree().set_pause(true) # Pre-pause
    # The rest is the same as in the code in the previous section (look above)




var players_done = []
remote func done_preconfiguring(who):
    # Here is some checks you can do, as example
    assert(get_tree().is_network_server())
    assert(who in player_info) # Exists
    assert(not who in players_done) # Was not added yet

    players_done.append(who)

    if (players_done.size() == player_info.size()):
        rpc("post_configure_game")

remote func post_configure_game():
    get_tree().set_pause(false)
    # Game starts now!



is_network_master()


[...]
# Load my player
var my_player = preload("res://player.tscn").instance()
my_player.set_name(str(get_tree().get_network_unique_id()))
my_player.set_network_mode(NETWORK_MODE_MASTER)
get_node("/root/world/players").add_child(my_player)

# Load other players
for p in player_info:
    var player = preload("res://player.tscn").instance()
    player.set_name(str(p))
    player.set_network_mode(NETWORK_MODE_SLAVE)
    get_node("/root/world/players").add_child(player)
[...]




#send moves, color and name over net
#create dictionary?

#random starting position









# end:
	get_tree().set_network_peer(null)
