extends Node2D

func _ready():

	#set tutorial hidden
	$Sprite.hide()

	#load lights and color pickers from global
	$Environment/player_1_light.set_color(global.color_1)
	$Environment/player_2_light.set_color(global.color_2)
	$color_player_1.set_pick_color(global.color_1)
	$color_player_2.set_pick_color(global.color_2)

	#load connection info from global
	$remote_host_ip.set_text(global.connect_ip)
	$remote_host_port.set_value(global.connect_port)
	$listen_port_port.set_value(global.listen_port)

	#load difficulty
	$difficulty.select(global.difficulty)

func _process(delta):

	#update global from color picker, update lights for global
	global.color_1 = $color_player_1.get_pick_color()
	global.color_2 = $color_player_2.get_pick_color()
	$Environment/player_1_light.set_color(global.color_1)
	$Environment/player_2_light.set_color(global.color_2)

	#update global from text fields
	global.connect_ip = $remote_host_ip.get_text()
	global.connect_port = $remote_host_port.get_value()
	global.listen_port = $listen_port_port.get_value()

	#update global from difficulty
	global.difficulty = $difficulty.get_selected()

	#show tutorial picture on "?"-button hover
	if $tutorial.is_hovered():
		$Sprite.show()
	else:
		$Sprite.hide()

	#reset
func _on_reset_pressed():
	$color_player_1.set_pick_color(global.def_color_1)
	$color_player_2.set_pick_color(global.def_color_2)
	$remote_host_ip.set_text(global.def_connect_ip)
	$remote_host_port.set_value(global.def_connect_port)
	$listen_port_port.set_value(global.def_listen_port)

	#goto main scene
func _on_quit_to_menu_pressed():
	get_tree().change_scene("Scenes/Menu_Main.tscn")